//////// question2.sce: ////////
// exec question2.sce

exec methodes.sci
exec library.sci


N=10;
dt=0.02;
T=0.4;
[x,t,v]=eqc(N,dt,T);


[xx,tt]=meshgrid(x,t);

close()
subplot(2,2,1)
surf(xx,tt,v')

size(xx)
size(tt)
size(v')
size(x)
size(t)

subplot(2,2,2)
contour(t,x,v',12)

uu=uc(xx,tt);
size(uu)
size(xx)
size(tt)
subplot(2,2,3)
surf(xx,tt,uu)


subplot(2,2,4)
contour(t,x,uu,12)


[x,t,v,err]=eqc_(N,dt,T);
err

pause

close()
surf(xx,tt,v'-uu)

N=200
[x,t,v,err]=eqc_(N,dt,T);
err


dt=0.01
[x,t,v,err]=eqc_(N,dt,T);
err

taberr=[];
tabdt=[0.02 0.01 0.005 0.002 0.001];
for dt=tabdt
[x,t,v,err]=eqc_(N,dt,T);
taberr=[taberr,err];
end

close()
plot(tabdt,taberr,'o-')


tabdt=log(tabdt);
taberr=log(taberr);
r=(taberr(2:$)-taberr(1:$-1))./(tabdt(2:$)-tabdt(1:$-1))

taberrt=[tabdt;taberr]

pause

close()
plot(tabdt,taberr,'o-')


/// Schema explicite-implicite

N=10;
dt=0.02;
T=0.4;
[x,t,v,err]=eqc2(N,dt,T);
[xx,tt]=meshgrid(x,t);

pause

close()
subplot(2,2,1)
surf(xx,tt,v')

uu=uc(xx,tt);
subplot(2,2,2)
surf(xx,tt,uu)

w=v'-uu;
subplot(2,2,3)
surf(xx,tt,w)

subplot(2,2,4)
contour(t,x,w,12)

taberr=[];
tabdt=[0.02 0.01 0.005 0.002 0.001];
for dt=tabdt
[x,t,v,err]=eqc2(N,dt,T);
taberr=[taberr,err];
end

tabdt=log(tabdt);
taberr=log(taberr);
r=(taberr(2:$)-taberr(1:$-1))./(tabdt(2:$)-tabdt(1:$-1))

taberrt=[tabdt;taberr]

pause

close()
plot(tabdt,taberr,'o-')

// Schema explicite

N=20;
dt=0.02;
T=0.4;

[x,t,v,err]=eqc1(N,dt,T);
[xx,tt]=meshgrid(x,t);

pause

close()
subplot(2,2,1)
surf(xx,tt,v')

uu=uc(xx,tt);
subplot(2,2,2)
surf(xx,tt,uu)

w=v'-uu;
subplot(2,2,3)
surf(xx,tt,w)


subplot(2,2,4)
contour(t,x,w,12)

// Schema explicite rétrograde

N=20;
dt=0.02;
T=0.4;

[x,t,v,err]=eqc1b(N,dt,T);
[xx,tt]=meshgrid(x,t);

pause

close()
subplot(2,2,1)
surf(xx,tt,v')

uu=uc(xx,tt);
subplot(2,2,2)
surf(xx,tt,uu)

w=v'-uu;
subplot(2,2,3)
surf(xx,tt,w)


subplot(2,2,4)
contour(t,x,w,12)


///////////////
// explicite

N=10;
dt=0.005; // 0.02;
T=0.4;
[x,t,v]=eqc1(N,dt,T);


[xx,tt]=meshgrid(x,t);

pause

close()
subplot(2,2,1)
surf(xx,tt,v')


subplot(2,2,2)
contour(t,x,v',12)

uu=uc(xx,tt);
subplot(2,2,3)
surf(xx,tt,uu)


subplot(2,2,4)
contour(t,x,uu,12)


[x,t,v,err]=eqc_(N,dt,T);
err

pause

close()
surf(xx,tt,v'-uu)

