#jupyter lab
#python question01.py

import numpy as np
import pylab as pl
import methodes as met
import library  as lib




t=np.linspace(0,1,101)
ft=lib.f1(t)
pl.plot(t,ft,linewidth=0.5,color='red')
pl.show()
pl.close()


tabN=np.arange(10,101,10) #np.arange(100,1001,100) #
taberr=np.zeros(len(tabN))
i=0
for N in tabN:
    x=np.linspace(0,1,N+2)
    f=lib.f1(x)
    #u1=sol1(x)
    x0=x[1:-1]
    f0=lib.f1(x0)
    pl.plot(x,f,linewidth=0.5,color='black')
    u0=met.laplace(f0,N)
    u0+=np.pi**2*u0
    u=np.zeros(N+2)
    u[1:-1]=u0
    #u=np.array([0]+u0.tolist()+[0])
    taberr[i]=np.linalg.norm(u-f) #sp.linalg.norm(u-f)
    i += 1
    pl.plot(x,u,linewidth=0.5,color='black')
pl.show()
pl.close()
print('Précision: ',taberr[-1])

pl.plot(x,u,linewidth=0.5,color='black')
t=np.linspace(0,1,101)
ft=lib.f1(t)
pl.plot(t,ft,linewidth=0.5,color='red')
pl.show()
pl.close()

taberr=np.log(taberr)
tabN=np.log(tabN)
pl.plot(tabN,taberr,linewidth=0.5,color='black')
pl.show()
pl.close()

pente=(taberr[1:]-taberr[0:-1])/(tabN[1:]-tabN[0:-1])
print(pente)

# Exemple 2

t=np.linspace(0,1,101)
sol2t=lib.sol2(t)
pl.plot(t,sol2t,linewidth=0.5,color='black')
#pl.plot([0,0],[-0.25,0.1],linewidth=0.5,color='grey')
#pl.plot([0,1],[0,0],linewidth=0.5,color='grey')
#pl.show()
#pl.close()

tabN=np.arange(10,101,10) #np.arange(100,1001,100) #
taberr=np.zeros(len(tabN))
i=0
for N in tabN:
    x=np.linspace(0,1,N+2)
    f=lib.f2(x)
    x0=x[1:-1]
    f0=lib.f2(x0)
    sol2x=lib.sol2(x)
    pl.plot(x,sol2x,linewidth=0.5,color='black')
    u0=met.laplace(f0,N)
    #u0=np.pi**2*u0
    u=np.zeros(N+2)
    u[1:-1]=u0
    #u=np.array([0]+u0.tolist()+[0])
    taberr[i]=np.linalg.norm(u-sol2x)
    i += 1
    pl.plot(x,u,linewidth=0.5,color='black')
pl.show()
pl.close()
print('Précision: ',taberr[-1])

pl.plot(x,u,linewidth=0.5,color='black')
t=np.linspace(0,1,101)
sol2t=lib.sol2(t)
pl.plot(t,sol2t,linewidth=0.5,color='red')
pl.show()
pl.close()

taberr=np.log(taberr)
tabN=np.log(tabN)
pl.plot(tabN,taberr,linewidth=0.5,color='black')
pl.show()
pl.close()

pente=(taberr[1:]-taberr[0:-1])/(tabN[1:]-tabN[0:-1])
print(pente)


