#jupyter lab
#python question01b.py

import numpy as np
import pylab as pl
import methodes as met
import library as lib



t=np.linspace(0,1,101)
ft=lib.f3(t)
pl.plot(t,ft,linewidth=0.5,color='red')
pl.show()
pl.close()

tabN=np.arange(10,101,10) #np.arange(100,1001,100) #
taberr=np.zeros(len(tabN))
i=0
for N in tabN:
    x=np.linspace(0,1,N+2)
    f=lib.f3(x)
    #u1=sol1(x)
    x0=x[1:]
    f0=lib.f3(x0)
    pl.plot(x,f,linewidth=0.5,color='black')
    u0=met.laplaceb(f0,N)
    u0+=np.pi**2*u0/4
    u=np.zeros(N+2)
    u[1:]=u0
    #u[-1]=u0[-1]
    #u=np.array([0]+u0.tolist()+[0])
    taberr[i]=np.linalg.norm(u-f)
    i += 1
    pl.plot(x,u,linewidth=0.5,color='black')
pl.show()
pl.close()
print('Précision: ',taberr[-1])

pl.plot(x,u,linewidth=0.5,color='red')
t=np.linspace(0,1,101)
ft=lib.f3(t)
pl.plot(t,ft,linewidth=0.5,color='red')
pl.show()
pl.close()

taberr=np.log(taberr)
tabN=np.log(tabN)
pl.plot(tabN,taberr,linewidth=0.5,color='black')
pl.show()
pl.close()

pente=(taberr[1:]-taberr[0:-1])/(tabN[1:]-tabN[0:-1])
print(pente)

# Exemple 2

t=np.linspace(0,1,101)
sol1t=lib.sol1(t)
pl.plot(t,sol1t,linewidth=0.5,color='black')
#pl.plot([0,0],[-0.25,0.1],linewidth=0.5,color='grey')
#pl.plot([0,1],[0,0],linewidth=0.5,color='grey')
#pl.show()
#pl.close()

tabN=np.arange(10,101,10) #np.arange(100,1001,100) #
taberr=np.zeros(len(tabN))
i=0
for N in tabN:
    x=np.linspace(0,1,N+2)
    f=lib.f4(x)
    x0=x[1:]
    f0=lib.f4(x0)
    sol1x=lib.sol1(x)
    pl.plot(x,sol1x,linewidth=0.5,color='black')
    u0=met.laplaceb(f0,N)
    #u0=np.pi**2*u0
    u=np.zeros(N+2)
    u[1:]=u0
    #u[-1]=u0[-1]
    #u=np.array([0]+u0.tolist()+[0])
    taberr[i]=np.linalg.norm(u-sol1x)
    i += 1
    pl.plot(x,u,linewidth=0.5,color='black')
pl.show()
pl.close()
print('Précision: ',taberr[-1])

pl.plot(x,u,linewidth=0.5,color='red')
t=np.linspace(0,1,101)
sol1t=lib.sol1(t)
pl.plot(t,sol1t,linewidth=0.5,color='red')
pl.show()
pl.close()

taberr=np.log(taberr)
tabN=np.log(tabN)
pl.plot(tabN,taberr,linewidth=0.5,color='black')
pl.show()
pl.close()

pente=(taberr[1:]-taberr[0:-1])/(tabN[1:]-tabN[0:-1])
print('Pente: ',pente)


    
    
    