#jupyter lab
#python question01d.py

from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import numpy as np
import pylab as pl
import methodes as met


n=10
x,y,uh,ue,err=met.diffini(n)
print('Precision: ',err)
ax=plt.axes(projection='3d')
ax.plot_surface(x,y,uh,color='whitesmoke')
plt.show()
plt.close()

ax=plt.axes(projection='3d')
ax.plot_surface(x,y,ue,color='whitesmoke')
plt.show()
plt.close()

ax=plt.axes(projection='3d')
ax.plot_surface(x,y,uh-ue,color='whitesmoke')
plt.show()
plt.close()

tabn=np.array([2,5,7,10,15,20,38,75])
taberr=np.zeros(len(tabn))
taberrn=np.zeros(len(tabn))
i=0
for n in tabn: # np.arange(0,len(tabn)):
    x,y,uh,ue,err=met.diffini(n)
    errn=np.max(abs(uh-ue))
    taberr[i]=err
    taberrn[i]=errn
    i+=1

print('Precision: ',taberr)
print('Erreur: ',taberrn)    

taberrn=np.log(taberrn)
tabn=np.log(tabn)
plt.plot(tabn,taberrn,'o-')
plt.show()
plt.close()

taberr0=np.log(taberr[1:])
tabn0=tabn[:-1]
plt.plot(tabn0,taberr0,'o-')
plt.show()
plt.close()




